	.386
	assume	cs:_TEXT
_TEXT	segment	para public USE16 'CODE'

; syntax of local label is different between 386ASM and TASM.
; in 386ASM, local label is `#1'.
; in TASM is `@@1', and require `LOCALS' declaration

	public	_coco_maxfree
_coco_maxfree proc near
	push	cx
	mov	ah,20H	; query free memory
	int	8eH
	mov	ax,cx
	pop	cx
	ret
_coco_maxfree endp

	public	_coco_alloc
_coco_alloc proc near
	push	bp
	mov	bp,sp
	push	cx
	push	di
	mov	cx,4[bp]	; size in KB
	mov	ah,21H		; alloc
	int	8eH
	jc	alloc1
	mov	ax,di
alloc2:
	pop	di
	pop	cx
	pop	bp
	ret
alloc1:
	xor	dx,dx
	xor	ax,ax
	jmp	alloc2
_coco_alloc endp

	public	_coco_free
_coco_free proc near
	push	bp
	mov	bp,sp
	push	di
	mov	di,4[bp]
	mov	dx,6[bp]
	mov	ah,22H		; free
	int	8eH
	pop	di
	pop	bp
	ret
_coco_free endp

	public	_coco_copy
_coco_copy proc near
	push	bp
	mov	bp,sp
	push	bx
	push	cx
	push	si
	push	di
	mov	si,4[bp]	; src
	mov	bx,6[bp]
	mov	di,8[bp]	; dst
	mov	dx,10[bp]
	mov	cx,12[bp]	; size
	mov	ah,23H		; copy
	int	8eH
	pop	di
	pop	si
	pop	cx
	pop	bx
	pop	bp
	ret
_coco_copy endp

_TEXT	ends
	end
