	.386
	assume	cs:_TEXT
_TEXT	segment	para public USE16 'CODE'

; syntax of local label is different between 386ASM and TASM.
; in 386ASM, local label is `#1'.
; in TASM is `@@1', and require `LOCALS' declaration

	; XMS driver
driver_off dw	0
driver_seg dw	0

	public	_xms_check
_xms_check proc near
	push	es
	push	bx
	mov	ax,4300H	; installation check
	int	2fH
	cmp	al,80H
	jne	check1
	
	mov	ax,4310H	; get driver address
	int	2fH
	mov	driver_seg, es
	mov	driver_off, bx
	xor	ax,ax
check2:
	pop	bx
	pop	es
	ret
check1:
	mov	ax,-1
	jmp	check2
_xms_check endp

	public	_xms_maxfree
_xms_maxfree proc near
	push	bx
	mov	ah,88H	; query free memory (XMS 3.0)
	call	dword ptr driver_off
	cmp	bl,00H
	jne	maxfree1
	mov	edx,eax
	shr	edx,16
maxfree2:
	pop	bx
	ret
maxfree1:
	mov	dx,0ffffH
	mov	ax,0ffffH
	jmp	maxfree2
_xms_maxfree endp

	public	_xms_alloc
_xms_alloc proc near
	push	bp
	mov	bp,sp
	push	bx
	mov	edx,4[bp]	; size in KB
	mov	ah,89H		; alloc
	call	dword ptr driver_off
	cmp	ax,0001H
	jne	alloc1
	mov	ax,dx
alloc2:
	pop	bx
	pop	bp
	ret
alloc1:
	mov	ax,-1
	jmp	alloc2
_xms_alloc endp

	public	_xms_lock
_xms_lock proc near
	push	bp
	mov	bp,sp
	push	bx
	mov	dx,4[bp]	; xms handle
	mov	ah,0cH		; lock
	call	dword ptr driver_off
	cmp	ax,0001H
	jne	lock1
	mov	ax,bx
lock2:
	pop	bx
	pop	bp
	ret
lock1:
	mov	dx,0ffffH
	mov	ax,0ffffH
	jmp	lock2
_xms_lock endp

	public	_xms_unlock
_xms_unlock proc near
	push	bp
	mov	bp,sp
	push	bx
	mov	dx,4[bp]	; xms handle
	mov	ah,0dH		; unlock
	call	dword ptr driver_off
	pop	bx
	pop	bp
	ret
_xms_unlock endp

	public	_xms_free
_xms_free proc near
	push	bp
	mov	bp,sp
	push	bx
	mov	dx,4[bp]	; xms handle
	mov	ah,0aH		; free
	call	dword ptr driver_off
	pop	bx
	pop	bp
	ret
_xms_free endp

	public	_xms_copy
_xms_copy proc near
	push	bp
	mov	bp,sp
	push	bx
	push	si
	mov	si,4[bp]	; param block
	mov	ah,0bH		; block transfer
	call	dword ptr driver_off
	pop	si
	pop	bx
	pop	bp
	ret
_xms_copy endp

	public	_xms_info
_xms_info proc near
	push	bp
	mov	bp,sp
	push	bx
	push	cx
	mov	dx,4[bp]	; handle
	mov	ah,8eH		; get info
	call	dword ptr driver_off
	cmp	ax,0001H
	je	info1
	mov	ax,-1
	jmp	info2
info1:
	mov	ax,dx
info2:
	pop	cx
	pop	bx
	pop	bp
	ret
_xms_info endp

_TEXT	ends
	end
